<?php
/**
* Plugin Name: EchBay Optimize Images
* Description: Set token key for access to admin page
* Plugin URI: https://www.facebook.com/groups/wordpresseb
* Plugin Facebook page: https://www.facebook.com/webgiare.org
* Author: Dao Quoc Dai
* Author URI: https://www.facebook.com/ech.bay/
* Version: 1.1.2
* Text Domain: webgiareorg
* Domain Path: /languages/
* License: GPLv2 or later
* Document: https://developers.google.com/speed/docs/insights/OptimizeImages
* https://www.imagemagick.org/script/convert.php
*/
define( 'EOI_DF_DIR', dirname( __FILE__ ) . '/' );
define( 'EOI_COOKIES_FOR_MODIFE', 'EOI_cokies_token_for_admin_url' );
$eoi_nen = 80;
if ( isset( $_GET[ 'nen' ] ) ) {
$eoi_nen = ( int )$_GET[ 'nen' ];
if ( $eoi_nen <= 0 ) {
$eoi_nen = 80;
}
}
define( 'EOI_COMPRESSION_JPG', $eoi_nen );
if ( !defined( 'ABSPATH' ) ) {
if ( isset( $_GET[ 'remove_backup_file' ] ) ) {
die( EOI_check_and_remove_backup_file() );
} else {
die( EOI_check_and_resize_image_now() );
}
}
define( 'EOI_DF_VERSION', '1.1.2' );
define( 'EOI_THIS_PLUGIN_NAME', 'EchBay Optimize Images' );
if ( !defined( 'EBP_GLOBAL_PLUGINS_SLUG_NAME' ) ) {
define( 'EBP_GLOBAL_PLUGINS_SLUG_NAME', 'echbay-plugins-menu' );
define( 'EBP_GLOBAL_PLUGINS_MENU_NAME', 'Webgiare Plugins' );
define( 'EOI_ADD_TO_SUB_MENU', false );
}
else {
define( 'EOI_ADD_TO_SUB_MENU', true );
}
/*
* class.php
*/
function EOI_create_token_for_resize() {
return md5( substr( md5( str_replace( 'www.', '', $_SERVER[ 'HTTP_HOST' ] ) ), 5, 5 ) );
}
if ( !class_exists( 'EOI_Actions_Module' ) ) {
class EOI_Actions_Module {
/*
* config
*/
var $default_setting = array(
'license' => '',
'hide_powered' => 1,
'compression_number' => 80,
'max_width_height' => 0,
'max_filesize' => 255
);
var $custom_setting = array();
var $eb_plugin_data = '';
var $eb_plugin_media_version = EOI_DF_VERSION;
var $eb_plugin_prefix_option = '___eoi___';
var $eb_plugin_root_dir = '';
var $eb_plugin_url = '';
var $eb_plugin_nonce = '';
var $eb_plugin_admin_dir = 'wp-admin';
var $eb_eoi_backup_path = 'zzz-eoi-bak-';
var $gio_server = 0;
var $web_link = '';
/*
* begin
*/
function load() {
/*
* Check and set config value
*/
$this->eb_plugin_root_dir = basename( EOI_DF_DIR );
$this->eb_plugin_media_version = filemtime( EOI_DF_DIR . 'admin.js' );
$this->eb_plugin_url = plugins_url() . '/' . $this->eb_plugin_root_dir . '/';
$this->eb_plugin_nonce = $this->eb_plugin_root_dir . EOI_DF_VERSION;
if ( defined( 'WP_ADMIN_DIR' ) ) {
$this->eb_plugin_admin_dir = WP_ADMIN_DIR;
}
$this->gio_server = current_time( 'timestamp' );
/*
if ( $this->gio_server != time() ) {
$tz = get_option('timezone_string');
if ( $tz != '' ) {
$this->gio_server = time();
}
}
*/
/*
* Load custom value
*/
$this->get_op();
}
function get_op() {
global $wpdb;
$pref = $this->eb_plugin_prefix_option;
$sql = $wpdb->get_results( "SELECT option_name, option_value
FROM
`" . $wpdb->options . "`
WHERE
option_name LIKE '{$pref}%'
ORDER BY
option_id", OBJECT );
foreach ( $sql as $v ) {
$this->custom_setting[ str_replace( $this->eb_plugin_prefix_option, '', $v->option_name ) ] = $v->option_value;
}
/*
* https://codex.wordpress.org/Validating_Sanitizing_and_Escaping_User_Data
*/
foreach ( $this->default_setting as $k => $v ) {
if ( !isset( $this->custom_setting[ $k ] ) ||
$this->custom_setting[ $k ] == '' ) {
$this->custom_setting[ $k ] = $v;
}
}
foreach ( $this->custom_setting as $k => $v ) {
if ( $k == 'custom_style' ) {
$v = esc_textarea( $v );
} else {
$v = esc_html( $v );
}
$this->custom_setting[ $k ] = $v;
}
}
function get_admin_link() {
return $this->get_web_link() . '/' . $this->eb_plugin_admin_dir . '/admin.php?page=' . strtolower( str_replace( ' ', '-', EOI_THIS_PLUGIN_NAME ) );
}
function get_web_link() {
if ( $this->web_link != '' ) {
return $this->web_link;
}
/*
if ( defined('WP_SITEURL') ) {
$this->web_link = WP_SITEURL;
}
else if ( defined('WP_HOME') ) {
$this->web_link = WP_HOME;
}
else {
*/
$this->web_link = get_option( 'siteurl' );
$this->web_link = explode( '/', $this->web_link );
$this->web_link[ 2 ] = $_SERVER[ 'HTTP_HOST' ];
$this->web_link = implode( '/', $this->web_link );
if ( substr( $this->web_link, -1 ) == '/' ) {
$this->web_link = substr( $this->web_link, 0, -1 );
}
return $this->web_link;
}
function get_file_in_folder( $open_folder, $type = '', $brace = '' ) {
if ( $brace != '' ) {
$arr = glob( $open_folder . $brace, GLOB_BRACE );
} else {
$arr = glob( $open_folder . '*' );
}
if ( $type == 'file' ) {
$arr = array_filter( $arr, 'is_file' );
foreach ( $arr as $k => $v ) {
$arr[ $k ] = basename( $v );
}
} else if ( $type == 'dir' ) {
$arr = array_filter( $arr, 'is_dir' );
}
foreach ( $arr as $k => $v ) {
$arr[ $k ] = str_replace( '../', '', $v );
}
return $arr;
}
function update() {
if ( $_SERVER[ 'REQUEST_METHOD' ] == 'POST' && isset( $_POST[ '_ebnonce' ] ) ) {
if ( !wp_verify_nonce( $_POST[ '_ebnonce' ], $this->eb_plugin_nonce ) ) {
wp_die( '404 not found!' );
}
foreach ( $_POST as $k => $v ) {
if ( substr( $k, 0, 5 ) == '_eoi_' ) {
$key = $this->eb_plugin_prefix_option . substr( $k, 5 );
$v = ( int )$v;
/*
}
else {
$v = stripslashes ( stripslashes ( stripslashes ( $v ) ) );
$v = strip_tags( $v );
$v = sanitize_text_field( $v );
}
*/
delete_option( $key );
if ( $v > 0 ) {
add_option( $key, $v, '', 'no' );
}
}
}
die( '<script type="text/javascript">
try {
if ( top != self && typeof top.a_lert == "function" ) {
top.a_lert("Update done!");
}
else {
alert("Update done!");
}
} catch (e) {
alert("Update done!");
}
</script>' );
} // end if POST
}
function admin() {
global $wpdb;
$arr = wp_upload_dir();
$path = dirname( $arr[ 'path' ] );
$basedir = $arr[ 'basedir' ];
$baseurl = $arr[ 'baseurl' ];
$current_dir_content = str_replace( $this->get_web_link(), '', $baseurl );
$root_path_host = substr( ABSPATH, 0, -1 );
$all_sizes = get_intermediate_image_sizes();
$all_sizes[] = 'full';
$all_sizes = array_reverse( $all_sizes );
/*
foreach ( $all_sizes as $v ) {
echo $v . '<br>';
}
*/
$total_post = 0;
$sql = $wpdb->get_results( "SELECT COUNT(ID)
FROM
`" . $wpdb->posts . "`
WHERE
post_type = 'attachment'", OBJECT );
if ( isset( $sql[ 0 ] ) ) {
$sql = $sql[ 0 ];
foreach ( $sql as $v ) {
$total_post = $v;
}
}
$post_per_page = 50;
$trang = isset( $_GET[ 'trang' ] ) ? ( int )$_GET[ 'trang' ] : 1;
$totalPage = ceil( $total_post / $post_per_page );
if ( $trang > $totalPage ) {
$trang = $totalPage;
} else if ( $trang < 1 ) {
$trang = 1;
}
$offset = ( $trang - 1 ) * $post_per_page;
if ( $offset < 0 ) {
$offset = 0;
}
$sql = $wpdb->get_results( "SELECT *
FROM
`" . $wpdb->posts . "`
WHERE
post_type = 'attachment'
ORDER BY
ID DESC
LIMIT " . $offset . ", " . $post_per_page, OBJECT );
$arr_list_file = array();
$arr_list_backup_file = array();
foreach ( $sql as $v ) {
foreach ( $all_sizes as $v2 ) {
$a = wp_get_attachment_image_src( $v->ID, $v2 );
if ( !isset( $arr_list_file[ $a[ 0 ] ] ) ) {
if ( $v2 == 'full' ) {
$file_full_path = $root_path_host . strstr( $a[ 0 ], $current_dir_content );
if ( file_exists( $file_full_path ) && is_file( $file_full_path ) ) {
$arr_file_full_size = getimagesize( $file_full_path );
$arr_list_file[ $a[ 0 ] ] = $v2 . '|' . $arr_file_full_size[ 0 ] . 'x' . $arr_file_full_size[ 1 ];
$check_backup_file = explode( '/', $file_full_path );
$check_backup_file[ count( $check_backup_file ) - 1 ] = $this->eb_eoi_backup_path . basename( $file_full_path );
$check_backup_file = implode( '/', $check_backup_file );
if ( file_exists( $check_backup_file ) ) {
$arr_list_backup_file[] = $check_backup_file;
}
}
else {
echo 'File not found! ' . $file_full_path . '<br>' . "\n";
$arr_list_file[ $a[ 0 ] ] = $v2 . '|' . $a[ 1 ] . 'x' . $a[ 2 ];
}
}
else {
$arr_list_file[ $a[ 0 ] ] = $v2 . '|' . $a[ 1 ] . 'x' . $a[ 2 ];
}
}
}
}
$str_list_file = '';
foreach ( $arr_list_file as $k => $v ) {
$str_list_file .= '<div data-path="' . $k . '" data-size="' . $v . '" data-filesize="' . ceil( filesize( str_replace( $baseurl, $basedir, $k ) ) / 1000 ) . '"></div>';
}
$str_list_bak_file = '';
foreach ( $arr_list_backup_file as $v ) {
$str_list_bak_file .= '<li data-path="' . $v . '"></li>';
}
$this->eb_plugin_media_version = $this->gio_server;
$this->get_web_link();
echo '<link rel="stylesheet" href="' . $this->eb_plugin_url . 'admin.css?v=' . $this->eb_plugin_media_version . '" type="text/css" />';
$main = file_get_contents( EOI_DF_DIR . 'admin.html', 1 );
$main = $this->template( $main, $this->custom_setting );
$main = $this->template( $main, $this->default_setting, 'aaa' );
$main = $this->template( $main, array(
'js' => 'var EOI_url_for_process="' . $this->eb_plugin_url . basename( __FILE__ ) . '?token=' . EOI_create_token_for_resize() . '",
current_dir_upload="' . urlencode( $basedir ) . '",
EOI_baseurl="' . urlencode( $baseurl ) . '",
EOI_img_wh_max=' . $this->custom_setting[ 'max_width_height' ] . ',
EOI_img_max_filesize=' . $this->custom_setting[ 'max_filesize' ] . ',
EOI_img_min_filesize=' . ceil( $this->default_setting[ 'max_filesize' ] / 2 ) . ',
EOI_compression_number=' . $this->custom_setting[ 'compression_number' ] . ',
EOI_cookies_for_modife="' . EOI_COOKIES_FOR_MODIFE . '",
EOI_path_for_backup_file="' . $this->eb_eoi_backup_path . '",
EOI_total_page=' . $totalPage . ',
EOI_current_page=' . $trang . ',
EOI_post_per_page=' . $post_per_page . ',
EOI_total_post=' . $total_post . ';',
'_ebnonce' => wp_create_nonce( $this->eb_plugin_nonce ),
'EOI_COMPRESSION_JPG' => EOI_COMPRESSION_JPG,
'plugin_name' => EOI_THIS_PLUGIN_NAME,
'plugin_version' => EOI_DF_VERSION,
'plugin_link' => $this->get_admin_link(),
'web_link' => $this->web_link,
'str_list_file' => $str_list_file,
'str_list_bak_file' => $str_list_bak_file,
'custom_setting' => $this->eb_plugin_data,
) );
echo $main;
echo '<script type="text/javascript" src="' . $this->eb_plugin_url . 'admin.js?v=' . $this->eb_plugin_media_version . '"></script>';
echo '<p>* Other <a href="' . $this->web_link . '/' . $this->eb_plugin_admin_dir . '/plugin-install.php?s=itvn9online&tab=search&type=author" target="_blank">WordPress Plugins</a> written by the same author. Thanks for choose us!</p>';
}
function template( $temp, $val = array(), $tmp = 'tmp' ) {
foreach ( $val as $k => $v ) {
$temp = str_replace( '{' . $tmp . '.' . $k . '}', $v, $temp );
}
return $temp;
}
} // end my class
} // end check class exist
class EOI_SimpleImage {
var $image;
var $image_width;
var $image_height;
var $image_type;
function load( $filename ) {
$image_info = getimagesize( $filename )or die( $filename );
$this->image_width = $image_info[ 0 ];
$this->image_height = $image_info[ 1 ];
$this->image_type = $image_info[ 2 ];
if ( $this->image_type == IMAGETYPE_GIF ) {
$this->image = imagecreatefromgif( $filename );
} elseif ( $this->image_type == IMAGETYPE_PNG ) {
$this->image = imagecreatefrompng( $filename );
} else {
$this->image = imagecreatefromjpeg( $filename );
}
}
function save( $filename, $image_type = '', $compression = EOI_COMPRESSION_JPG, $permissions = null ) {
if ( $image_type == '' )$image_type = $this->image_type;
if ( $image_type == IMAGETYPE_GIF ) {
imagegif( $this->image, $filename );
} elseif ( $image_type == IMAGETYPE_PNG ) {
imagepng( $this->image, $filename, 0, PNG_NO_FILTER );
} else {
imagejpeg( $this->image, $filename, $compression );
}
if ( $permissions != null ) {
chmod( $filename, $permissions );
}
}
function output( $image_type = '' ) {
if ( $image_type == '' )$image_type = $this->image_type;
if ( $image_type == IMAGETYPE_JPEG ) {
imagejpeg( $this->image );
} elseif ( $image_type == IMAGETYPE_GIF ) {
imagegif( $this->image );
} elseif ( $image_type == IMAGETYPE_PNG ) {
imagepng( $this->image );
}
}
function getWidth() {
return imagesx( $this->image );
}
function getHeight() {
return imagesy( $this->image );
}
function resizeToHeight( $height ) {
$ratio = $height / $this->getHeight();
$width = $this->getWidth() * $ratio;
$this->resize( $width, $height );
}
function resizeToWidth( $width ) {
$ratio = $width / $this->getWidth();
$height = $this->getheight() * $ratio;
$this->resize( $width, $height );
}
function scale( $scale ) {
$width = $this->getWidth() * $scale / 100;
$height = $this->getheight() * $scale / 100;
$this->resize( $width, $height );
}
function resize( $width, $height ) {
$new_image = imagecreatetruecolor( $width, $height );
if ( $this->image_type == IMAGETYPE_PNG ) {
imagealphablending( $new_image, false );
imagesavealpha( $new_image, true );
$transparent = imagecolorallocatealpha( $new_image, 255, 255, 255, 127 );
imagefilledrectangle( $new_image, 0, 0, $width, $height, $transparent );
}
imagecopyresampled( $new_image, $this->image, 0, 0, 0, 0, $width, $height, $this->getWidth(), $this->getHeight() );
$this->image = $new_image;
}
}
function EOI_resize_png( $source_file, $dst_file, $new_width, $new_height, $width = 0, $height = 0 ) {
if ( $width == 0 || $height == 0 ) {
$a = getimagesize( $source_file );
$width = $a[ 0 ];
$height = $a[ 1 ];
}
return EOI_resize_images( $source_file, $dst_file, $new_width, $new_height, $width, $height );
/*
$source_image = imagecreatefrompng($source_file);
$image = imagecreatetruecolor($new_width, $new_height);
imagealphablending($image, false);
imagesavealpha($image, true);
$transparent = imagecolorallocatealpha($image, 255, 255, 255, 127);
imagefilledrectangle($image, 0, 0, $width, $height, $transparent);
imagecopyresampled($image, $source_image, 0, 0, 0, 0, $new_width, $new_height, $width, $height);
imagepng( $image, $dst_file, 0, PNG_NO_FILTER );
*/
$image = imagecreatefrompng( $source_file );
$bg = imagecreatetruecolor( imagesx( $image ), imagesy( $image ) );
imagefill( $bg, 0, 0, imagecolorallocate( $bg, 255, 255, 255 ) );
imagealphablending( $bg, true );
imagecopy( $bg, $image, 0, 0, 0, 0, imagesx( $image ), imagesy( $image ) );
imagejpeg( $bg, $file_resize, EOI_COMPRESSION_JPG );
}
function EOI_resize_images( $source_file, $dst_file, $new_width, $new_height, $width = 0, $height = 0 ) {
$image = new EOI_SimpleImage();
$image->load( $source_file );
if ( $width == 0 || $height == 0 ) {
$a = getimagesize( $source_file );
$width = $a[ 0 ];
$height = $a[ 1 ];
}
if ( $new_width == $new_height ) {
if ( $width > $height ) {
$image->resizeToWidth( $new_width );
} else {
$image->resizeToHeight( $new_height );
}
} else if ( $new_width > $new_height ) {
$image->resizeToWidth( $new_width );
} else {
$image->resizeToHeight( $new_height );
}
$image->save( $dst_file, '', EOI_COMPRESSION_JPG );
echo ' <strong>SimpleImage</strong>; ';
}
function EOI_check_function_is_enabled( $func ) {
if ( function_exists( $func ) ) {
return true;
}
return false;
}
function EOI_recopy( $parent_file, $file_resize ) {
if ( $parent_file == $file_resize ) {
return true;
}
if ( !copy( $parent_file, $file_resize ) ) {
return false;
}
if ( !chmod( $file_resize, 0766 ) ) {
if ( !unlink( $file_resize ) ) {
echo ' <font color="#FF0000">ERROR</font> remove file <em>' . $file_resize . '</em>; ';
}
if ( !copy( $parent_file, $file_resize ) ) {
echo ' <font color="#FF0000">ERROR</font> re-copy file <em>' . $file_resize . '</em>; ';
return false;
}
if ( !chmod( $file_resize, 0766 ) ) {
echo ' <font color="#FF0000">ERROR</font> chmod <em>' . $file_resize . '</em>; ';
}
}
return true;
}
function EOI_check_size_after_resize( $parent_file, $file_parent_size, $file_resize ) {
$check_new_size = filesize( $file_resize );
echo ' New size: ' . ceil( $check_new_size / 1000 ) . 'kb; ';
if ( $check_new_size > $file_parent_size ) {
if ( EOI_recopy( $parent_file, $file_resize ) ) {
echo ' <strong><em>Recopy file</em></strong> ';
} else {
echo ' <font color="#FF0000"><strong><em>ERROR Recopy file</em></strong></font> ';
}
return false;
}
return true;
}
function EOI_check_token_or_cookie() {
if ( !isset( $_GET[ 'token' ] ) ||
$_GET[ 'token' ] != EOI_create_token_for_resize() ||
!isset( $_GET[ 'file' ] ) ) {
die( 'Parameter not found' );
}
if ( !isset( $_COOKIE[ EOI_COOKIES_FOR_MODIFE ] ) ) {
exit();
}
return true;
}
function EOI_check_and_resize_image_now( $reload_this_func = 1 ) {
EOI_check_token_or_cookie();
$file_path = isset( $_GET[ 'path' ] ) ? urldecode( $_GET[ 'path' ] ) : '';
if ( $file_path == '' || !is_dir( $file_path ) ) {
die( 'Dir not found: ' . $file_path );
}
$file_resize = isset( $_GET[ 'file' ] ) ? $file_path . urldecode( $_GET[ 'file' ] ) : '';
if ( $file_resize == '' || !file_exists( $file_resize ) ) {
die( 'File not found: ' . $file_resize );
}
if ( isset( $_GET[ 'nooptimize' ] ) ) {
die( 'This file has been set <strong>Not optimize</strong>; Filesize: ' . number_format( ceil( filesize( $file_resize ) / 1000 ) ) . 'kb' );
}
if ( !isset( $_GET[ 'current_width' ] ) || !isset( $_GET[ 'current_height' ] ) ) {
die( 'SIZE not found' );
}
$current_width = ( int )$_GET[ 'current_width' ];
$current_height = ( int )$_GET[ 'current_height' ];
$parent_file = isset( $_GET[ 'parent_file' ] ) ? $file_path . urldecode( $_GET[ 'parent_file' ] ) : '';
if ( $parent_file == '' || !file_exists( $parent_file ) ) {
die( 'Source file not found: ' . $parent_file );
}
$arr_parent_size = getimagesize( $parent_file );
$file_parent_size = filesize( $parent_file );
echo ' Source file: ' . $arr_parent_size[ 'mime' ] . '(' . number_format( ceil( $file_parent_size / 1000 ) ) . 'kb) ';
if ( isset( $_GET[ 'parent_backup_file' ] ) ) {
$parent_backup_file = $file_path . urldecode( $_GET[ 'parent_backup_file' ] );
/*
if ( file_exists( $parent_backup_file ) ) {
unlink( $parent_backup_file );
echo ' <strong style="color:#f00;">TEST TEST TEST</strong> ';
}
*/
if ( !file_exists( $parent_backup_file ) ) {
if ( EOI_recopy( $parent_file, $parent_backup_file ) ) {
echo ' <em>Backup parent file</em>; ';
}
}
else {
$before_resize = filesize( $parent_backup_file );
$after_resize = filesize( $parent_file );
if ( $after_resize > $before_resize ) {
if ( !EOI_recopy( $parent_backup_file, $parent_file ) ) {
echo ' <font color="#FF0000">ERROR</font> ';
}
echo ' <font color="#0000FF"><em>Copy in backup file</em></font>; ';
}
else {
echo ' <em>Parent file resize only one</em>! ';
}
echo ' <strong>Before resize</strong>: ' . number_format( ceil( $before_resize / 1000 ) ) . 'kb; ';
echo ' <strong>After resize</strong>: ' . number_format( ceil( $after_resize / 1000 ) ) . 'kb; ';
die( ' <strong>Done! BIG file has been resize</strong>! ' );
}
}
switch ( $arr_parent_size[ 'mime' ] ) {
case "image/jpeg":
case "image/png":
case "image/gif":
break;
default:
die( ' <span class="redcolor">File type: ' . $arr_parent_size[ 'mime' ] . ' not support</span> ' );
}
if ( $current_width - 10 > $arr_parent_size[ 0 ] ) {
EOI_recopy( $parent_file, $file_resize );
die( 'Copy source file only! ' . $current_width . ' &gt; ' . $arr_parent_size[ 0 ] );
}
if ( !isset( $_GET[ 'resize_big_file' ] ) ) {
$check_thumb = explode( '-', $file_resize );
$check_thumb = $check_thumb[ count( $check_thumb ) - 1 ];
$check_thumb = explode( '.', $check_thumb );
$check_thumb = explode( 'x', $check_thumb[ 0 ] );
if ( count( $check_thumb ) != 2 ) {
die( 'Function for thumbail only' );
}
}
$arr_size = getimagesize( $file_resize );
$old_size = filesize( $file_resize );
echo ' New file: ' . $arr_size[ 'mime' ] . '(' . number_format( ceil( $old_size / 1000 ) ) . 'kb); ';
echo ' Compression: <strong>' . EOI_COMPRESSION_JPG . '</strong>; ';
$str_for_exec = 'magick convert ' . $file_resize . ' -resize ' . $current_width . 'x' . $current_height . ' -strip -quality ' . EOI_COMPRESSION_JPG . ' ' . $file_resize;
/*
if ( EOI_check_function_is_enabled('exec') == true ) {
echo ' <em>exec Enable</em>; ';
} else {
echo ' <em>exec Disable</em>; ';
}
*/
if ( class_exists( 'Imagick' ) && EOI_check_function_is_enabled( 'exec' ) ) {
if ( EOI_recopy( $parent_file, $file_resize ) ) {
if ( exec( $str_for_exec, $error_output ) ) {
echo ' <strong>Using: exec Imagick</strong>; ';
} else {
echo ' <font color="#FF0000">ERROR</font> <strong>exec Imagick</strong>; ';
echo ' <em>"' . $str_for_exec . '"</em> ';
/*
EOI_imagick_resize_images ( $parent_file, $file_resize, $current_width, $current_height, $arr_parent_size );
exit();
*/
}
print_r( $error_output );
if ( $reload_this_func == 1
&&
$arr_parent_size[ 'mime' ] == 'image/jpeg' ) {
echo ' ---------- <font color="#00FF00">reload JPG</font>; ';
EOI_check_and_resize_image_now( 0 );
}
else if ( !EOI_check_size_after_resize( $parent_file, $file_parent_size, $file_resize ) &&
$reload_this_func == 1 ) {}
} else {
echo ' <font color="#FF0000">ERROR</font> <strong>copy file for optimize</strong>; ';
}
exit();
}
/*
if ( $arr_parent_size['mime'] == 'image/jpeg' ) {
EOI_resize_images( $parent_file, $file_resize, $current_width, $current_height, $arr_parent_size[0], $arr_parent_size[1] );
}
else {
*/
if ( $current_width == $current_height && $arr_parent_size[ 0 ] != $arr_parent_size[ 1 ] ) {
echo ' Resize small thumb - ';
}
/*
else if ( $old_size <= $file_parent_size ) {
die('<em>File has been resize</em>');
}
*/
else if ( $old_size <= $file_parent_size && $arr_parent_size[ 'mime' ] != 'image/jpeg' ) {
die( '<em>File has been resize</em>' );
}
if ( class_exists( 'Imagick' ) ) {
EOI_imagick_resize_images( $parent_file, $file_resize, $current_width, $current_height, $arr_parent_size );
} else if ( $arr_parent_size[ 'mime' ] == 'image/jpeg' ) {
EOI_resize_images( $parent_file, $file_resize, $current_width, $current_height, $arr_parent_size[ 0 ], $arr_parent_size[ 1 ] );
} else if ( $arr_parent_size[ 'mime' ] == 'image/png' ) {
EOI_resize_png( $parent_file, $file_resize, $current_width, $current_height, $arr_parent_size[ 0 ], $arr_parent_size[ 1 ] );
}
else if ( $old_size > $file_parent_size ) {
EOI_recopy( $parent_file, $file_resize );
}
/*
}
*/
/*
if ( $arr_parent_size['mime'] == IMAGETYPE_PNG ) {
$file_type = 'png';
}
else if ( $arr_parent_size['mime'] == IMAGETYPE_JPEG ) {
$file_type = 'jpg';
}
else if ( $arr_parent_size['mime'] == IMAGETYPE_GIF ) {
$file_type = 'gif';
}
else {
$file_type = explode( '.', $parent_file );
$file_type = $file_type[ count( $file_type ) - 1 ];
}
$file_test = dirname( $file_resize ) . '/EOI_check_img_after_resize.' . $file_type;
EOI_recopy( $file_resize, $file_test );
*/
if ( $reload_this_func == 1
&&
$arr_parent_size[ 'mime' ] == 'image/jpeg' ) {
echo ' ---------- <font color="#00FF00">reload JPG (2)</font>; ';
EOI_check_and_resize_image_now( 0 );
}
else if ( !EOI_check_size_after_resize( $parent_file, $file_parent_size, $file_resize ) &&
$reload_this_func == 1 ) {}
}
function EOI_imagick_resize_images( $parent_file, $file_resize, $current_width, $current_height, $arr_parent_size ) {
$image = new Imagick();
$image->readImage( $parent_file );
if ( $arr_parent_size[ 0 ] > $arr_parent_size[ 1 ] ) {
$image->resizeImage( $current_width, 0, Imagick::FILTER_CATROM, 1 );
} else {
$image->resizeImage( 0, $current_height, Imagick::FILTER_CATROM, 1 );
}
if ( $arr_parent_size[ 'mime' ] == 'image/jpeg' ) {
$image->setImageFormat( 'jpg' );
$image->setImageCompression( Imagick::COMPRESSION_JPEG );
$image->setImageCompressionQuality( EOI_COMPRESSION_JPG );
} else {
$image->setImageCompression( Imagick::COMPRESSION_UNDEFINED );
$image->optimizeImageLayers();
}
$image->stripImage();
$image->writeImages( $file_resize, true );
$image->destroy();
echo ' <strong>Using: Imagick</strong>; ';
}
function EOI_check_and_remove_backup_file() {
EOI_check_token_or_cookie();
$f = $_GET[ 'file' ];
if ( !file_exists( $f ) ) {
echo 'File not found!';
}
if ( unlink( $f ) ) {
echo 'REMOVE backup file: ';
} else {
echo 'ERROR remove backup file: ';
}
echo basename( $f );
}
/*
* Show in admin
*/
function EOI_show_setting_form_in_admin() {
global $EOI_func;
$EOI_func->update();
$EOI_func->admin();
}
function EOI_admin_menu() {
if ( !current_user_can( 'manage_options' ) ) {
return false;
}
$a = EOI_THIS_PLUGIN_NAME;
if ( EOI_ADD_TO_SUB_MENU == false ) {
add_menu_page( $a, EBP_GLOBAL_PLUGINS_MENU_NAME, 'manage_options', EBP_GLOBAL_PLUGINS_SLUG_NAME, 'EOI_show_setting_form_in_admin', NULL, 99 );
}
add_submenu_page( EBP_GLOBAL_PLUGINS_SLUG_NAME, $a, trim( str_replace( 'EchBay', '', $a ) ), 'manage_options', strtolower( str_replace( ' ', '-', $a ) ), 'EOI_show_setting_form_in_admin' );
}
function EOI_plugin_settings_link( $links ) {
$settings_link = '<a href="admin.php?page=' . strtolower( str_replace( ' ', '-', EOI_THIS_PLUGIN_NAME ) ) . '">Settings</a>';
array_unshift( $links, $settings_link );
return $links;
}
if ( is_admin() ) {
$EOI_func = new EOI_Actions_Module();
$EOI_func->load();
add_action( 'admin_menu', 'EOI_admin_menu' );
if ( strpos( $_SERVER[ 'REQUEST_URI' ], '/plugins.php' ) !== false ) {
$plugin = plugin_basename( __FILE__ );
add_filter( "plugin_action_links_$plugin", 'EOI_plugin_settings_link' );
}
}